; ACL2 Version 1.8

; Copyright (C) 1989-95 Computational Logic, Inc. (CLI).  All rights reserved.

; Use of this software constitutes agreement with the terms of ACL2
; license agreement, found in the file LICENSE.

(in-package "ACL2")

; In each case, we include the necessary books (presumably because at
; least something needs to be included in order to provide the
; necessary packages), then we certify a book, then we undo back to
; the start, avoiding all queries by using :u.

(certify-book "rational-listp" 0 nil)

:u

(defpkg 
  "ACL2-ASG"
  (union-eq *acl2-exports*
            *common-lisp-symbols-from-main-lisp-package*))
(defpkg 
  "ACL2-AGP"
  (union-eq *acl2-exports*
            *common-lisp-symbols-from-main-lisp-package*))
(defpkg 
  "ACL2-CRG"
  (union-eq *acl2-exports*
            *common-lisp-symbols-from-main-lisp-package*))

(certify-book "equalities" 3 nil)
:u :u :u :u

(certify-book "inequalities" 0 nil)
:u

(certify-book "rationals-with-axioms" 0 nil)

:u

; Build the top-level book.

(certify-book "top" 0 nil)
