; ACL2 Version 1.8

; Copyright (C) 1989-95 Computational Logic, Inc. (CLI).  All rights reserved.

; Use of this software constitutes agreement with the terms of ACL2
; license agreement, found in the file LICENSE.

(in-package "ACL2")

(defthm append-preserves-rational-listp
  (implies (true-listp x)
           (equal (rational-listp (append x y))
                  (and (rational-listp x)
                       (rational-listp y)))))

(defthm rationalp-car-rational-listp
  (implies (and (rational-listp x)
		x)
	   (rationalp (car x)))
  :rule-classes :forward-chaining)
