
in-package "acl2";

/* (DEFSTUB subr1 (x y state ) T ) == (DEFSTUB subr1 (x y state ) FOO ) */

SIGNATURE test1 (x, y, state) ;        /* => (DEFSTUB subr1 (x y state ) T ) */

SIGNATURE test1 (x, y, state) : state; /* => (DEFSTUB subr1 (x y state ) state ) */

SIGNATURE test1 (x, y, state) : foo;   /* => (DEFSTUB subr1 (x y state ) foo ) + typeaxiom*/

SIGNATURE test1 (x, y, state) : bar;

SIGNATURE subr1 (x, y, state) : < T, state>;

SIGNATURE subr1 (x : integer, y : boolean) : < integer, character>;

/* The above should return
(defstub subr1 (x y)(mv integerp character))
(defaxiom subr-type 
  (implies (and (integerp x) (booleanp y))
	   (and (integerp (mv-nth 0 (subr x Y)))
		(characterp (mv-nth 1 (subr x Y)))))) */

SIGNATURE subr1 (x, y) : < integer, character>;

/* The above should return
(defstub subr1 (x y)(mv integerp character))
(defaxiom subr-type
  (and (integerp (mv-nth 0 (subr x Y)))
       (characterp (mv-nth 1 (subr x Y))))) */

module 
{ subr1 (x, y, state) : < T, state>; } 
{ function foo () { 19; }; };

theorem foo { bar(x) -> bim(x) } 
:rule-classes :forward-chaining;
