
in-package "acl2";

/* sbar testing */
axiom sbar 
{ bar (x) -> bar-zero (y) };
/* :rule-classes :rewrite; */

type foo = integer ;

function foo(x) {intergerp(x)};

type bar = enum [a, b, c];

function foo (x : integer, y : integer | moo(x)): integer
 { if x < y then 1+ x else 1- y ;}
 :measure p(x);

function seqfoo (x : integer, y : integer): integer
 { z := f(x,1);
   w := goo(f(x,3),y);
   result(z,w,x); }
 :measure p(x);

const *digits* := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9];

Disable moo;

MACRO pop-key-name(l, key, name) name[1];

Theorem eval-exp-list-val-type-prescription
{ flg -> true-listp (eval-exp-val (flg, x, vs)) ; } 
 :rule-classes :type-prescription;

Module 
{ AVA-MIN-INT() : INTEGERP;
  AVA-MAX-INT() : INTEGERP;} 
{ 
    /* Local constant. */
  
  local Function ava-min-int () { -32000 } ;
  local Function ava-max-int () { 32000 } ;
  
  /* Testing doc of !qintegerp-ava-min-int. */
  
  Theorem integerp-ava-min-int { integerp (ava-min-int) & (ava-min-int < 0) } 
   :rule-classes :type-prescription ;
  
  /* Testing doc of !qintegerp-ava-max-int. */
  
  Theorem integerp-ava-max-int { integerp (ava-max-int) &  (0 < ava-max-int) } 
  :rule-classes :type-prescription;
  
  Theorem min-int-close-to-max-int {  (ava-max-int + ava-min-int) <= 1  } ;
  
  };

TYPE person = 
 RECORD( name : STRING := "John", age : INTEGER := 19, sex : STRING := "male");

/* Text */
Label interp-section "documentation" ;

Theory ava-op-fns := 
current(:here) difference function(ava-op-fns-start);

signature subr1 (x, y, state) : < T, state>;

Label interp-section;

function some-x-y-p-and-q(z)
{ exists x, y |  p (x, y, z) & q (x, y, z) };

:u;

:oops;

:pbt :max;
:pbt 34;
:pe :x-30;

:pcs [:max -2];

:pf [:definition foo];
:pf [:rewrite foo];
:pf foo;

:pbt [:search [ 1 2 ] :max 0];
