

Theorem len-nth-seg

{ i + j <= len(l) -> len(nth-seg(i,j,l)) = min(nfix(j),max(len(l) - nfix(i),0)) }
 :hints [["Goal" :do-not-induct t
                 :in-theory                    current-theory(:here)
                                    difference '[[:definition nth-seg]]
                             union '[nth-seg-non-recursive-defun]]]; 

Theory list-defuns :=             current-theory(:here)
                       difference current-theory('list-defuns-section);


 set-inhibit-warnings("theory");


skip-proofs { 

Theorem cancel_binop-rel-correct-lemma
{    binop-rel(ev1(binary-op_tree(binop-name(),
                                  binop-id(),
                                  binop-fix-name(),
                                  bagdiff(binary-op_fringe(binop-name(),x1),
                                          bagint(binary-op_fringe(binop-name(),
                                                                  x1),
                                                 binary-op_fringe(binop-name(),
                                                                  x2)))),
                   a),
               ev1(binary-op_tree(binop-name(),
                                  binop-id(),
                                  binop-fix-name(),
                                  bagdiff(binary-op_fringe(binop-name(),x2),
                                          bagint(binary-op_fringe(binop-name(),
                                                                  x1),
                                                 binary-op_fringe(binop-name(),
                                                                  x2)))),
                   a))
   = binop-rel(binop-fix(ev1(x1,a)),binop-fix(ev1(x2,a))) }; };




Theorem cancel_plus-equal-correct
{ ev2(x,a) = ev2(cancel_plus-equal(x),a) }
 :hints [["Goal" :by [:functional-instance cancel_binop-rel-correct
                                           [ev1 := ev2, 
                                            ev1-list := ev2-list, 
                                            binop := binary-plus, 
                                            binop-fix := fix, 
                                            binop-rel := =, 
                                            binop-id := lambda() { 0 }, 
                                            binop-name := lambda() { 'binary-plus }, 
                                            binop-fix-name := lambda() { 'fix }, 
                                            binop-rel-name := lambda() { '= }, 
                                            cancel_binop-rel$1 := cancel_plus$1, 
                                            cancel_binop-rel := cancel_plus-equal ]]]];


Module { }
{ 
  Macro implies-x(x,y) = 
  IF y THEN t
     ELSE ~x;
  
  local Theorem implies*-is-implies { (a -> b) = implies*(a,b) };
  
   };