
in-package "acl2";

type bar = enum [a, b, c];

Theorem test-dots { f('[a . b]) };

Theorem test-dots { f('[a.b]) };

Theorem test-dots { '[a.b] = [c.d] & '[a b d . e] = ['[a . b], c.d] };

Theorem test-list { '[a . [d . e]] = '[[a . b] c] };

/* (DEFTHM equal-minus-lemma
    (implies (acl2-numberp a )(EQUAL a b ))
    :HINTS ((("Goal" :use foo )))) */
Theorem equal-minus-lemma  { acl2-numberp(a) -> a = b }
 :hints [["Goal" :use foo]];

/* (DEFTHM equal-minus-lemma
    (implies (acl2-numberp a )(EQUAL a b ))
    :HINTS ((("Goal" :use  (:instance foo ))))) */
Theorem equal-minus-lemma  { acl2-numberp(a) -> a = b }
 :hints [["Goal" :use [:instance foo]]];

Theorem equal-minus-lemma  { acl2-numberp(a) -> a = b }
 :hints [["Goal" :use [[:instance foo]]]];

Theorem equal-minus-lemma  { acl2-numberp(a) -> a = b }
 :hints [["Goal" :use [[:instance [:theorem      fc(acl2-numberp(a))]
                                  [a a] [b b]]]]];

Theorem equal-minus-lemma  { acl2-numberp(a) -> a = b }
 :hints [["Goal" :use [[:instance [:theorem      fc(acl2-numberp(a))
                                                 & fc(acl2-numberp(b))
                                                 & fc(a ~= 0)
                                                 & fc(b ~= 0)
                                              -> (a = b -> / a = / b)] 
                                  [a a] [b b]]]]]

