
in-package("acl2");

constant *day*  = 'Mon ;

constant *temp* : integer = 24 ;

constant *digits* = '[0 1 2 3 4 5 6 7 8 9];

constant *three* : integer  = 3;

type foo = integer ;

type foo = integer *;

type foo = [integer . character] *;

type bar = enum [a, b, c];

type PERSON = record ( name : string := "John", 
                        age : integer := 19, 
                        sex : string := "male");

function xxx (day) {
 case day {
  'mon : 1;
  'tue : 2;
  'wed : 3;
  'thu : 4;
  'fri : 5;
  else : 0;}};

Axiom sbar 
{ bar (x) -> bar-zero (y);}
 :rule-classes [:rewrite] ;

function foo (x , y) { x + y };

function foo (x : integer, y : integer | bar(x)): integer
 { if x < y then 1 + x else y - 1 ;}
 :measure p(x);

function some-x-y-p-and-q(z)
{ exists x, y |  p(x, y, z) & q(x, y, z) };

function some-x-y-p-and-q(z : int): boolean
{ exists x, y |  p(x, y, z) & q(x, y, z) };

function all-keyword(l)
{ for x in l, when keywordp(x), collect x };

Function keyword-listp(l)
{ for x in l, forall keywordp(x) };

Function keyword-listp(l)
{ for x in l, exists keywordp(x) };

Function keyword-listp(l)
{ for x in l, never keywordp(x) };

macro pop-key-name(name) = name[1];

macro pop-key-name(name) # name[1];

signature test1 (x, y, state) ;
/* (defstub-signature test1 (x y state) T) */

signature subr1 (x, y, state) : < T, state>;
/* (defstub-signature subr1 (x y state) (MV T state)) */

signature subr2(x, y, state) : foo;
/* (defstub-signature subr2 (x y state) foo :AXIOM (foo (subr2 x y state))) */

signature subr3 (x : integer, y : boolean) : < integer, character>;
/* (Defstub-Signature subr3 (x y ) (MV INTEGER character )
    :AXIOM (IMPLIES (AND (INTEGERP x )(BOOLEANP y ))(MV (subr3 x y )))) */

theorem eval-exp-list-val-type-prescription
{ flg -> true-listp (eval-exp+-val (flg, x, vs)) ; } 
 :rule-classes :type-prescription;

module 
{ an-element(lst) : t;}
{ local function an-element(lst)
        { if consp(lst) then car(lst)
              else nil };
  local theorem member-equal-car
         { lst & true-listp(lst) -> car(lst) in lst };
  theorem thm1 { null(lst) -> null(an-element(lst)) };
  theorem thm2
  { true-listp(lst) & ~(null(lst)) -> an-element(lst) in lst }; };

Module foo
{ an-element(lst) : t; } 
{ local 
  Function an-element(lst)
  { IF consp(lst) then car(lst)
         else nil };
  local 
  Theorem member-equal-car
  { lst & true-listp(lst) -> car(lst) in lst };
  Theorem thm1 { null(lst) -> null(an-element(lst)) };
  Theorem thm2
  { true-listp(lst) & ~(null(lst)) -> an-element(lst) in lst }; };

theory ava-op-fns := 
            current-theory(:here) 
 difference union-theories(function-theory('ava-op-fns-start), disable(moo));



in-theory(            current-theory(:here)
           difference '[flatten [:executable-counterpart flatten]]);

label interp-section ;

package "my-pkg" = union-eq(*acl2-exports*,
                         *common-lisp-symbols-from-main-lisp-package*);


Function bim() { [
a & b & c & d, 
a & (b & (c & d)), 
((a & b) & c) & d, 
x * y * y = x * y * y  ,
1 / 2 / 3            ,  
2 + 3 + 3 + 3        ,  
(2 + 3) + 3 + 3      ,  
((2 + 3) + 3) + 3    ,  
2 + (3 + (3 + 3))    ,  
(2 / 3) * 1          ,  
2 / 3 * 1            ,  
~ ~ a        ,  
-x                     ,
(- x)                  ,
-x                     ,
2 + (3 + (4 + 5))     , 
t -> nil,
1 - 2 - 3 - 4,
1 * 2 * 3 * 4,
1 / 2 / 3 / 4,
1/2/3/4       ,
-x,                /* (- x ) */
(- x),             /* (- x ) */
-(f(x))            /* (- (f x )) */

 ]};

constant *foo* : integer = 23; 
