
in-package("acl2");

/* function bim (x,y,z,w) { ~ x | y -> z & w }*/
Function bim(x, y, z, w) { ~ x | y -> z & w };

/* function bim (x,y,z,w) { ~ (x | y) -> z & w }*/
Function bim(x, y, z, w) { ~ (x | y) -> z & w };

/* function bim (x,y,z,w) { ~z | z & w }*/
Function bim(x, y, z, w) { ~ z | z & w };

/* function bim (x,y,z,w) { x * y + z * w }*/
Function bim(x, y, z, w) { x * y + z * w };

/* function bim (x,y,z,w) { x + y - x}*/
Function bim(x, y, z, w) { x + y - x };

/* function bim (x,y,z,w) { x + y - x & w}*/
Function bim(x, y, z, w) { x + y - x & w };

/* function bim (x,y,z,w) { z - w + w}*/
Function bim(x, y, z, w) { z - w + w };

/* function bim (x,y,z,w) { x - y & z - w}*/
Function bim(x, y, z, w) { x - y & z - w };

/* function bim (x,y,z,w) { x * y + z * w < w -> f(x,y) * z > x }*/
Function bim(x, y, z, w) { x * y + z * w < w -> f(x, y) * z > x };

/* function bim (x,y,z,w) { -x + y - x}*/
Function bim(x, y, z, w) { - x + y - x };

/* function bim (x,y,z,w) { -(x + y) - x}*/
Function bim(x, y, z, w) { - x + y - x };

Function bim(x, y, z, w) { member-equal(~ x, '[1 "asdfa\"dad2" "\"" "a"]) -> foo(w) };

Function bim(x, y, z, w) { a * b + c * d + e * f };

Function bim(x, y, z, w) { a + b + c + d + e + f };

Function bim(x, y, z, w) 
{ for x in l, collect x };

function all-keyword(l)
{for x in l, when keywordp(x), collect x };

signature subr3 (x : integer, y : boolean) : < integer, character>;

theory ava-op-fns := 
 current-theory(:here) difference
   union-theories(function-theory(ava-op-fns-start), disable(moo));


Function bim() { [
a & b & c & d, 
a & (b & (c & d)), 
((a & b) & c) & d, 
x * y * y = x * y * y  ,
1 / 2 / 3            ,  
2 + 3 + 3 + 3        ,  
(2 + 3) + 3 + 3      ,  
((2 + 3) + 3) + 3    ,  
2 + (3 + (3 + 3))    ,  
(2 / 3) * 1          ,  
2 / 3 * 1            ,  
~ ~ a        ,  
-x                     ,
(- x)                  ,
-x                     ,
2 + (3 + (4 + 5))     , 
t -> nil,
1 - 2 - 3 - 4,
1 * 2 * 3 * 4,
1 / 2 / 3 / 4,
1/2/3/4       ,
-x,
(- x),
-(f(x))

 ]};

constant *foo* : integer = 23; 