; ACL2 Version 1.8

; Copyright (C) 1989-95 Computational Logic, Inc. (CLI).  All rights reserved.

; Use of this software constitutes agreement with the terms of ACL2
; license agreement, found in the file LICENSE.

(in-package "ACL2")

; In each case, we include the necessary books (presumably because at
; least something needs to be included in order to provide the
; necessary packages), then we certify a book, then we undo back to
; the start, avoiding all queries by using :u.

;; This cerifies the assorted cowles books.

;; (ld "cowles/certify.lisp")

;; We assume we start acl2 in the right dir. 
;; (set-cbd "/usr/cli/projects/cacl2/version20/solaris/books/")


(defpkg "U" (union-eq *acl2-exports*
                       *common-lisp-symbols-from-main-lisp-package*))

;; (certify-book "utilities" 1)

;; :u

(defpkg "STRUCTURES"
  (union-eq
   '(DEFSTRUCTURE)			;The main macro exported by this book.
   (union-eq
    *acl2-exports*
    (union-eq
     *common-lisp-symbols-from-main-lisp-package*
     '(access
       acl2-count add-to-set-eq add-to-set-equal arglistp
       assoc-equal assoc-keyword *built-in-executable-counterparts*
       car-cdr-elim car-cons cdr-cons change check-vars-not-free constant
       defrec duplicates e0-ord-< eqlablep er evens
       *expandable-boot-strap-non-rec-fns* 
       hard hide iff integer-abs intern-in-package-of-symbol
       intersection-eq keyword-value-listp legal-variable-or-constant-namep
       len logic make member-equal msg mv-nth no-duplicatesp pairlis$ program
       reason-for-non-keyword-value-listp 
       remove-duplicates-equal set-difference-equal set-equalp-equal
       set-ignore-ok state-global-let* symbol-listp 
       syntaxp trans trans1 true-listp zp

       u::defloop u::force-term-list
       u::get-option-argument u::get-option-as-flag
       u::get-option-check-syntax u::get-option-entry
       u::get-option-entries u::get-option-member
       u::get-option-subset u::pack-intern
       u::unique-symbols)))))

(certify-book "structures" 2)

:u

(certify-book "list-defuns" 2)

:u

(certify-book "alist-defuns" 2)

:u

(certify-book "deflist" 2)

:u

(certify-book "defalist" 2)

:u

(certify-book "list-defthms" 2)

:u

(certify-book "list-theory" 2)



