in-package ("acl2");

f(a, b);

'[list @ b c];

'[[3 . 3]
 [4 . 4]];



[ a , b, '==];

Theorem MAIN
{ HYPS(X,Y,Z) -> CONCL(X,Y,Z) }
 :rule-classes [:REWRITE :GENERALIZE]
 :instructions [ ==, INDUCT, ==, PROVE, PROMOTE, DIVE(1), X, DIVE(2), ==, TOP, DROP(2), PROVE ];


if x then y else cdr(x);


~~~x;


[1, 2, 3];

'[1 2 3] [3];

'[1 2 3].cdr;

'[1 2 3] [x];

a + b;
Function foo(x) { '+ :> x :> '1 :> 'nil }
 ;

Constant *one-shell-quote-mark* = 'nqthm::star-1-quote;


Function car-cdr-symbolp1(lst)
           { IF null(lst) then nil
                  elif eql(car(lst),'R') then null(cdr(lst))
                  else car(lst) in '[ 'A' 'D'] & car-cdr-symbolp1(cdr(lst)) }
 :mode :program;




x + y + z;
x.y.z;

(x.y).z;

[ ['a, 'b, 'c], 2, 3];

[['a, 'b, 'c], 2, 3][1] [3];


disable(member);

macro nqthm::in-package(x) = in-package(x @ nil);

Function ascii-code-lst(lst)
           { IF endp(lst) then 0
                  else ascii-code(car(lst)) :> ascii-code-lst(cdr(lst)) }
 :guard standard-char-listp(lst)
 :hints  [["Goal" :in-theory disable(member)]]
 :guard-hints[["Goal" :in-theory '[ :definition standard-char-listp] :> disable(member)]];

 [:rewrite, :corollar];

Function make-rewrite-corollaries(pairs)
           { IF null(pairs) then nil
                  else [:rewrite, 
                        :corollary, 
                        { hyps := caar(pairs);
                          { concl := cdar(pairs);
                            IF null(hyps) then concl
                                 elif null(cdr(hyps))
                                 then ['->, car(hyps), concl]
                                 else ['->, 
                                       '& :> hyps, 
                                       concl
                                       ]}}
                        ] :> make-rewrite-corollaries(cdr(pairs)) }
 :mode :program;


Macro nqthm::prove-lemma(name,rule-classes,term,&rest rst) # 
{ term := nqthm-translate(term);
  list*('defthm,
        name,
        term,
        :rule-casses,
        nqthm-to-acl2-rule-classes(term,rule-classes),
        rst)};

Macro nqthm::thm(&rest x) # 
list*('thm,nqthm-translate(car(x)),cdr(x));


Macro in-packa(&rest x) # 
list*('in-package, x);


list*('in-package, x);



Function constrain-witnesses(alist)
           { IF null(alist) then nil
                  else { formals := nqthm-translate-lst(cadr(cadr(car(alist))));
                         { body := nqthm-translate(caddr(cadr(car(alist))));
                           ['local, 
                            ['defun, 
                             car(car(alist)), 
                             formals, 
                             ['declare, 
                              list*('ignore,
                                    set-difference-eq(formals,
                                                      all-vars(body)))
                              ], 
                             body
                             ]
                            ]}} :> constrain-witnesses(cdr(alist)) }
 :mode :program;


Macro nqthm::constrain(name,rule-classes,term,alist,&rest rst) # 
list*('encapsulate,
      constrain-sigs(alist),
      constrain-witnesses(alist) @ [{ term := nqthm-translate(term);
                                      list*('defthm,
                                            name,
                                            term,
                                            :rule-classs,
                                            nqthm-to-acl2-rule-classes(term,
                                            rule-classes),
                                            rst)}
                                    ])
 :guard constrain-alistp(alist);


'[@ append 3 3];

['@ , 'append];

[[]];

[[], []];

[ nil ];

[[[]]];

[];

'[];

'[[] [a [list 3 3]]];

''[ '[ 2 3] 3];

'  '  '[ [2 [3]] [[[3]]]];


'[ 3 + 3];

'[ 3 + 3 [ + 3 3]];
'[3 [+ 3 3] 3 '[A B ] . 3];

'[ . . . ];


'[ 'a' "adsdas"];



Macro nqthm::note-lib(name,&optional compile-flg) # 
['include-book, 
 name, 
 IF null(compile-flg) | eq(compile-flg,'nil) then nil
      else t
 ];


f(g());


Macro alist-type-alistp-lemma(alist-type-fn,
                              dom-type-fn : ignore,
                              ran-type-fn : ignore,
                              dom-elem-type-fn : ignore,
                              ran-elem-type-fn : ignore,
                              formals : d,
                              &optional 
                              guard := 't) #
['->, my-conjoin(my-conjuncts(guard),[list*(alist-type-fn,formals)]), '[alistp l]]
 ;



macro foo(X) # x;







Macro alist-type-bind-lemma(alist-type-fn,
                            dom-type-fn : ignore,
                            ran-type-fn : ignore,
                            dom-elem-type-fn,
                            ran-elem-type-fn,
                            formals,
                            &optional 
                            guard := 't) #
{ vars := u::unique-symbols(2,
                          intern-in-package-of-symbol("X",alist-type-fn),
                          formals);
  var1 := car(vars);
  var2 := cadr(vars);
  ['->, 
   my-conjoin(my-conjuncts(guard),
              [list*(alist-type-fn,formals), 
               [dom-elem-type-fn, var1], 
               [ran-elem-type-fn, var2]
               ]), 
   list*(alist-type-fn,replace-equal('l,['bind, var1, var2, 'l],formals))
   ]}
 :guard a > b;



{ <a , b> := <3, 3>;
  
  a + b;};


{ a := 3;
  { b := 3;
  a + b; } };

{ <a , b, c> := < 3, 3, 4>;
   a + b + c;};


'[append @];

Include("alist-defuns");

Include("list-defuns");

Include("utilities");

function bc (x) : boolean
 { x + 1;};

MODULE {  } 
{ c + b; };

constant *a* : integer = 3;

"L" in formal-strings;

Function defalist-check-syntax(name,formals,body)
           { IF ~(symbolp(name))
                  then u::bomb('defalist,
                               "The function name must be a symbol, but ~p0 is not.",
                               name)
                  elif ~(true-listp(formals))
                  then u::bomb('defalist,
                               "The argument list ~p0 is not a true list.",
                               formals)
                  elif ~(arglistp(formals))
                  then { <elmt, msg> := find-first-bad-arg(formals);
                         u::bomb('defalist,
                                 "The argument list ~p0 is not valid because the ~
                          element ~p1 ~@2.",
                                 formals,
                                 elmt,
                                 msg) }
                  elif { formal-strings := u::mapcar-string(formals);
                         l-tail := "L" in formal-strings;
                         multiple-ls := "L" in cdr(l-tail);
                         ~l-tail | multiple-ls}
                  then u::bomb('defalist,
                               "The formal argument list to DEFALIST must be a valid ~
                       functional argument list that contains exactly 1 ~
                       symbol whose print-name is \"L\", but ~p0 is not.",
                               formals)
                  elif null(body)
                  then u::bomb('defalist,"The function body is empty!")
                  else { last-form := car(last(body));
                         optionsa := len(body) >= 2 & (true-listp(last-form) & eq(car(last-form), :options ));
                         predicate := IF options?
                                         then car(last(butlast(body,1)))
                                         else last-form;
                         IF consp(predicate) & { d := car(predicate);
                                                  { r := cdr(predicate);
                                                    symbolp(d) | (true-listp(d) & (len(d) >= 3 & (eq(first(d),
                                                                                                     'lambda) & (arglistp(second(d)) & len(second(d)) = 1)))) & (symbolp(r) | (true-listp(r) & (len(r) >= 3 & (eq(first(r),
                                                                                                                                                                                                                  'lambda) & (arglistp(second(r)) & len(second(r)) = 1)))))}}
                              then nil
                              else u::bomb('defalist,
                                           "The DEFALIST predicate designator must be a ~
                             pair (d . r) where d is either a function symbol
                             or a 1-argument LAMBDA function, and r ~
                             is either a function symbol or a 1-argument
                             LAMBDA function. ~p0 does not satisfy this
                             requirement.",
                                           predicate)} }
 :mode :program;

"ad\"cd\"a'sd";

:ad := 3;


function f(theor, a) { a + theory};


'@;


function f(theo, a) { v::and(a, b);};

Theorem fold-consts-in-plus
{ syntaxp(quotep(x)) & syntaxp(quotep(y)) -> x + (y + z) = x + y + z };



function fd(x)
{ x * y + c  + d;};


a + b + c + d;

a @ b @ c @ d;

a - b - c;

a := if (3 > 3) then 23 else 2;


''if;
''function;

''+;

/*
function foo(x, y,z)
{ FOR fn in theory1, 
       when case fn {
             binding :  ran-elem-type-fn ~= *defalist-true-fn* ;
             bound? :  dom-elem-type-fn ~= *defalist-true-fn* ;
             domain :  dom-type-fn ~= *defalist-true-fn* ;
             range :  ran-type-fn ~= *defalist-true-fn* ;
             t :  t ;
             }, 
            collect fn };
       
*/

Macro list-type-make-list-lemma(elem-type-fn,
                                list-type-fn,
                                formals,
                                &optional 
                                guard1 := 't) # 
{ vars := unique-symbols(3,intern-in-package-of-symbol("X",list-type-fn),formals);
  var1 := car(vars);
  var2 := cadr(vars);
  var3 := caddr(vars);
  guard2 := my-conjuncts(guard1);
  rule := ['iff, 
         list*(list-type-fn,
               replace-equal('l,['make-list-ac, var1, var2, var3],formals)), 
         ['and, 
          ['or, 
           ['zp, var1], 
           list*(elem-type-fn,
                 IF symbolp(elem-type-fn) then replace-equal('l,var2,formals)
                      else [var2])
           ], 
          list*(list-type-fn,replace-equal('l,var3,formals))
          ]
         ];
  IF guard2 then ['implies, my-conjoin(guards,nil), rule]
       else rule};

Function pack(lst)
           { IF unpacked-nqthm-litatomp(lst)
                  then { str := coerce(ascii-char-lst(lst),'string);
                         IF str = "IF" then 'if
                              elif str = "EQUAL" then 'equal
                              elif str = "NOT" then 'not
                              elif str = "IMPLIES" then 'implies
                              elif str = "IFF" then 'iff
                              elif str = "QUOTE" then 'quote
                              else intern-in-package-of-symbol(str,
                                                               'pack)}
                  else [*oneshell-quote-mark*, 'pack, lst] }
 :guard-hints[["[1]Goal" :in-theory enable(nqthm-litatom-char-codep)]];

Theorem len-plus-sum-lst-is-count-fn
{ all-nqthm-litatom-char-codep(lst) -> len(lst) + sum-lst(lst) = count-fn(t,lst) }
 :hints [["Goal" :in-theory disable(nqthm-litatom-char-codep)]];

Theorem nqthm-count-symbol-is-count-fn-unpack
{ litatom(x) & symbolp(x) -> nqthm-count-symbol(x) = 1 + count-fn(t,unpack(x)) }
 :hints [["Goal" :use [:instance len-plus-sum-lst-is-count-fn
                                 [lst := ascii-code-lst(coerce(symbol-name(x),
                                                             'list)) ]]
                 ]];
[['declare, 
                     ['xargs, 
                      :well-founded-relation, 
                      car(car(car(rst))), 
                      :measure, 
                      cadr(car(car(rst)))
                      ]]];

list*(a, b, :rule-classes);

macro foo(x) = in-package (if x then "as" else "foo");
 


function nqthm::a (x,y) { x + y };

Macro list-type-true-listp-lemma(elem-type-fn : lisp::ignore,
                                 list-type-fn,
                                 formals,
                                 lisp::&optional 
                                 guard := 'lisp::t) = x + y;

case fn {
         else :  car-rule-classes
        };

case fn {
           car :  car-rule-classes ;
           nth :  nth-rule-classes ;
           true-listp : '[:rewrite :forward-chaining] ;
           else :  '[:rewrite] ; } ;
list*(:instance)