

Include("/usr/cli/projects/cacl2/version13/infix-prelude");


in-package("acl2");


Function filter-alist-theory(theory1,
                             dom-elem-type-fn,
                             ran-elem-type-fn,
                             dom-type-fn,
                             ran-type-fn)
{ FOR fn in theory1, 
       when CASE fn {
        binding :  ran-elem-type-fn ~= *defalist-true-fn* ;
        bound? :  dom-elem-type-fn ~= *defalist-true-fn* ;
        domain :  dom-type-fn ~= *defalist-true-fn* ;
        range :  ran-type-fn ~= *defalist-true-fn* ;
        t :  t ;
        }, 
       collect fn };

;





